<?php

ini_set("allow_url_fopen", true);
header("Content-type: application/json; charset=UTF-8");

// POSTメソッドでリクエストした値を取得
$json = file_get_contents('php://input');
$jsons = urldecode($json);
$str = mb_convert_encoding($jsons, 'UTF8', 'ASCII,JIS,UTF-8,EUC-JP,SJIS-WIN');

//頭から８文字目以降を収納
$str2 = substr($str, 8);

//JSONデータデコード
$cs = json_decode($str2);

//コマンド取得
$cmd = $cs->cmd;

//recid取得
$recid = $cs->recid;

//レコードデータ取得
$recids = $cs->record->recid;
$name = $cs->record->name;
$price = $cs->record->price;

//ステータス
$res = Array();
$res['status']  = 'error';
$res['message'] = 'Command "'. $cmd .'" is not recognized.';
$res['postData']= $str2;


// データベース接続
// $host = localhostで動かなければipアドレスを記載
$host = 'mysql9999.xserver.jp';
// データベース名
$dbname = 'suzukia0129_test';
// ユーザー名
$dbuser = 'suzukia0129_testuser';
// パスワード
$dbpass = 'hogehoge';

// データベース接続クラスPDOのインスタンス$dbhを作成する
try {
	$dbh = new PDO("mysql:host={$host};dbname={$dbname};charset=utf8mb4", $dbuser, $dbpass);
// PDOExceptionクラスのインスタンス$eからエラーメッセージを取得
} catch (PDOException $e) {
	// 接続できなかったらvar_dumpの後に処理を終了する
	var_dump($e->getMessage());
	exit;
}

//コマンドで処理をわける
switch ($cmd) {

//データ取得処理
case 'get':
	//$recidが０の時は、全データ取得
	if ($recid == 0) {
		
		//検索用文字列のチェック
		if (is_array($cs->search)) {
			
			//検索用文字列あり
			$names = $cs->search[0]->value;
			
			// リストデータ取得用SQL
			// 値はバインドさせる
			$sql = "SELECT recid, name, price FROM products WHERE name LIKE '%" . $names . "%' ORDER BY recid ";
			// SQLをセット
			$stmt = $dbh->prepare($sql);
			// SQLを実行
			$stmt->execute();
			
			// あらかじめ配列$dataを作成する
			// 受け取ったデータを配列に代入する
			// 最終的にhtmlへ渡される
			$data = array();
			
			// fetchメソッドでSQLの結果を取得
			// 定数をPDO::FETCH_ASSOC:に指定すると連想配列で結果を取得できる
			// 取得したデータを$dataへ代入する
			while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
				$data[] = array(
					'recid' => $row['recid'],
					'name'  => $row['name'],
					'price' => $row['price']
				);
			}
			
			header("Content-Type: application/json;charset=utf-8");
			echo json_encode($data);
			//echo $names;
			
		} else {
			
			//検索用文字列なし
			
			// リストデータ取得用SQL
			// 値はバインドさせる
			$sql = "SELECT recid, name, price FROM products ORDER BY recid ";
			// SQLをセット
			$stmt = $dbh->prepare($sql);
			// SQLを実行
			$stmt->execute();
			
			// あらかじめ配列$dataを作成する
			// 受け取ったデータを配列に代入する
			// 最終的にhtmlへ渡される
			$data = array();
			
			// fetchメソッドでSQLの結果を取得
			// 定数をPDO::FETCH_ASSOC:に指定すると連想配列で結果を取得できる
			// 取得したデータを$dataへ代入する
			while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
				$data[] = array(
					'recid' => $row['recid'],
					'name'  => $row['name'],
					'price' => $row['price']
				);
			}
			
			header("Content-Type: application/json;charset=utf-8");
			echo json_encode($data);
			//echo json_encode($cs);
		}
	} else {
		
		//編集する１データのみ取得する
		
		//戻りJSON配列
		$data = Array();
		
		// １データ取得用SQL
		$sql = "SELECT recid, name, price FROM products WHERE recid = " . $recid . " ORDER BY recid LIMIT 1 ";
		// SQLをセット
		$stmt = $dbh->prepare($sql);
		// SQLを実行
		$stmt->execute();
		
		//ステータス項目
		$data['status'] = 'success';
		
		//データ項目
		while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
			$data['record'] = array(
				'recid' => $row['recid'],
				'name'  => $row['name'],
				'price' => $row['price']
			);
		}
		
		header("Content-Type: application/json;charset=utf-8");
		echo json_encode($data);
		
	}
	//header("Content-Type: application/json;charset=utf-8");
	//echo json_encode($cs);
	break;

//データ削除処理
case 'delete':
	
	//recidを取り出し
	$recid2 = $cs->selected[0];
	
	// １データ削除SQL
	$sql = "DELETE FROM products WHERE recid = " . $recid2;
	// SQLをセット
	$stmt = $dbh->prepare($sql);
	// SQLを実行
	$stmt->execute();
	
	$ress = Array();
	$ress['status']  = 'success';
	header("Content-Type: application/json;charset=utf-8");
	echo json_encode($ress);
	
	//echo json_encode($cs);
	//echo $recid2;
	break;

//追加、更新処理
case 'save':
	
	if ($recid == 0) {
		
		// データ追加用SQL
		// 値はバインドさせる
		$sql = "INSERT INTO products(name, price) VALUES(?, ?)";
		// SQLをセット
		$stmt = $dbh->prepare($sql);
		// SQLを実行
		$stmt->execute(array($name, $price));
		
		
		$ress = Array();
		$ress['status']  = 'success';
		//$ress['message'] = '';
		header("Content-Type: application/json;charset=utf-8");
		echo json_encode($ress);
		
	} else {
		
		// データ追加用SQL
		// 値はバインドさせる
		$sql = "UPDATE products SET name = '" . $name . "', price = " . $price . " WHERE recid = " . $recid;
		// SQLをセット
		$stmt = $dbh->prepare($sql);
		// SQLを実行
		$stmt->execute();
		
		
		$ress = Array();
		$ress['status']  = 'success';
		//$ress['message'] = '';
		header("Content-Type: application/json;charset=utf-8");
		echo json_encode($ress);
		//header("Content-Type: application/json;charset=utf-8");
		//echo json_encode($cs);
		//echo $sql;
	}
	
	break;

//それ以外の時は、JSONデータをそのまま返す
default:
	
	header("Content-Type: application/json;charset=utf-8");
	echo json_encode($cs);
	break;

}


?>